<?php

require_once 'lib/customlib/database/json/JSON.class.php';

/**
 * Description of ModalAdministrableDAO
 *
 * @author Luciano
 */
class ModalAdministrableDAO extends JSON {


    static private $table_param = array(
        "file_path" => "callout-index-header.json",
        "field_types" => array(
            "active" => "tinyint",
            "bgColor" => "varchar",
            "borderColor" => "varchar",
            "title" => "varchar",
            "titleColor" => "varchar",
            "text" => "varchar",
            "textColor" => "varchar",
            "btActive" => "tinyint",
            "btBgColor" => "varchar",
            "btBorderColor" => "varchar",
            "btText" => "varchar",
            "btTextColor" => "varchar",
            "modUrl" => "varchar",
            "modText" => "varchar"
        )
    );

    protected $active;                  //tinyint
    protected $bgColor;                //varchar
    protected $borderColor;            //varchar
    protected $title;                   //varchar
    protected $titleColor;             //varchar
    protected $text;                    //varchar
    protected $textColor;              //varchar
    protected $btActive;               //tinyint
    protected $btBgColor;             //varchar
    protected $btBorderColor;         //varchar
    protected $btText;                 //varchar
    protected $btTextColor;           //varchar
    protected $modUrl;                 //varchar
    protected $modText;


    public function getActive() {return $this->active;}
    public function getBgColor() {return $this->bgColor;}
    public function getBorderColor() {return $this->borderColor;}
    public function getTitle() {return $this->title;}
    public function getTitleColor() {return $this->titleColor;}
    public function getText() {return $this->text;}
    public function getTextColor() {return $this->textColor;}
    public function getBtActive() {return $this->btActive;}
    public function getBtBgColor() {return $this->btBgColor;}
    public function getBtBorderColor() {return $this->btBorderColor;}
    public function getBtText() {return $this->btText;}
    public function getBtTextColor() {return $this->btTextColor;}
    public function getModUrl() {return $this->modUrl;}
    public function getModText() {return $this->modText;}


    public function setActive($active) {$this->active = $active;}
    public function setBgColor($bgColor) {$this->bgColor = $bgColor;}
    public function setBorderColor($borderColor) {$this->borderColor = $borderColor;}
    public function setTitle($title) {$this->title = $title;}
    public function setTitleColor($titleColor) {$this->titleColor = $titleColor;}
    public function setText($text) {$this->text = $text;}
    public function setTextColor($textColor) {$this->textColor = $textColor;}
    public function setBtActive($btActive) {$this->btActive = $btActive;}
    public function setBtBgColor($btBgColor) {$this->btBgColor = $btBgColor;}
    public function setBtBorderColor($btBorderColor) {$this->btBorderColor = $btBorderColor;}
    public function setBtText($btText) {$this->btText = $btText;}
    public function setBtTextColor($btTextColor) {$this->btTextColor = $btTextColor;}
    public function setModUrl($modUrl) {$this->modUrl = $modUrl;}
    public function setModText($modText) {$this->modText = $modText;}


    public function __construct() {

    }

    static private function getFullFilePath(){
        return appConfig::DIRECTORY_DATABASE_URL. self::$table_param['file_path'];
    }

    static private function getJsonFile(){
        return self::open(self::getFullFilePath());
    }

    static public function isError(){
        return JSON::$error;
    }

    static public function getFieldType($fieldType){
        return self::$table_param['field_types'][$fieldType];
    }

    static public function getDataForDataTableJson(){
        return self::open(self::getFullFilePath());
    }

    static public function get(){
        $object = self::getJsonFile();
        
	if($object)
            $ret = self::getInstantiatedFromJson ($object);
        else
            $ret = false;


        return $ret;
    }

    static protected function getInstantiatedFromJson($obj) {
        $_ret = new ModalAdministrable();
        foreach ($obj as $key => $value) {
//            $key = strtolower($key);
            if (property_exists(__CLASS__, $key))
                $_ret->$key = $value;
        }
        return $_ret;
    }

    public function Persist() {

        $updateRet = self::Update_Insert($this);
        if($updateRet > 0){
            $_ret = statusResponse::getInstanceOk();
        }else{
            $_ret = statusResponse::getInstanceFromTableMsgCode(msgTable::ERROR_ENTITY_UPDATE_FAIL);
            $_ret->setDebugInfo(JSON::$error);
        }

        return $_ret;
    }

    static public function Update_Insert(ModalAdministrable &$obj){

        $array = $obj->toArray();

        $ret = parent::Update(self::getFullFilePath(),$array);
        
	return $ret;
    }


}
