<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

require_once 'lib/customlib/common/date_conversion/DateConversion.php';
require_once 'lib/customlib/database/rdbms/mysqlDAO.class.php';
require_once 'daoStructureJson.php';

/**
 * Description of daoStructure
 *
 * @author pc3
 */
class daoStructure extends mysqlDAO {

    private $table_param;
    private $table_name;
    
    function __construct($tableName) {
        $this->table_name = $tableName;              
        $this->table_param = daoStructureJson::getStructure($tableName);
    }

    public function getQueryForInstantiate($id) {
        
        
        $_table = $this->table_param->table;
        
        $_primary_key = $this->table_param->primary_key;                
        $_fieldTypes = $this->table_param->field_types;

        $_additional_select_fields = $this->table_param->additional_select_fields;

        // todo, propagar alias a las consulta (select) y al resulset. ver de agregarlo a la estructura.
        $_fieldsStr = " * ";
        
            $_where = "where $_table.$_primary_key = '$id' ";

            $_from = " from $_table ";
            $_from .= $this->getQueryFrom_WithJoinTables();
            $_from .= $this->getQueryFrom_WithLeftJoinTables();

            $_query = "select $_fieldsStr $_from $_where ";
            
        return $_query;
    }

    public function getQueryWithJoinTables(){

    }


    private function getQueryFrom_WithJoinTables() {

        $_persistRelations = new daoPersistRelations($this->table_param->oneToOneRel, array());
        
        $_innerJoinRelations = $_persistRelations->getOneToOneRelationList_onInnerJoinMode();
        
        $_from = "";

        foreach ($_innerJoinRelations as $_persistRelation) {

            if($_persistRelation->getAutoInstantiate()) {
                $_jtable = $_persistRelation->getTable();

                $_key = $_persistRelation->getRelKey();
                $_fkey = $_persistRelation->getForeignKey();
                $_from .= " inner join $_jtable ";
                $_from .= " on ( $_key = $_fkey )";
            }
        }
        
        

        return $_from;
    }

    private function getQueryFrom_WithLeftJoinTables() {

        $_persistRelations = new daoPersistRelations($this->table_param->oneToOneRel, array());
        
        $_innerJoinRelations = $_persistRelations->getOneToOneRelationList_onLeftJoinMode();
        $_from = "";

        foreach ($_innerJoinRelations as $_persistRelation) {

            if($_persistRelation->getAutoInstantiate()) {
                $_jtable = $_persistRelation->getTable();
                $_key = $_persistRelation->getRelKey();
                $_fkey = $_persistRelation->getForeignKey();
                $_from .= " left join $_jtable ";
                $_from .= " on ( $_key = $_fkey )";
            }

        }

        return $_from;

    }
    
    public function getFieldType($fieldName) {
        return $this->table_param->field_types->$fieldName->type;
    }

    public function getPrimaryKeyField(){
        return $this->table_param->primary_key;
    }
    
    public function getClassName(){
        return $this->table_param->className;
    }
    
    public function getClassPath() {
        return $this->table_param->classPath;
    }
    
    /**
     * Array con relaciones One to one
     * @return array
     */
    public function getOneToOneRelations(){
        $_ret = array();
        if(is_array($this->table_param->oneToOneRel))
            $_ret = $this->table_param->oneToOneRel;
        return $_ret;
    }

    /**
     * Array con relaciones One to many
     * @return array
     */
    public function getOneToManyRelations(){
        $_ret = array();
        if(is_array($this->table_param->oneToManyRel))
            $_ret = $this->table_param->oneToManyRel;
        return $_ret;
    }


    /**
     * @return array
     */
    public function getFieldTypesArray(){
        $_ret = array();
        foreach ($this->table_param->field_types as $prop => $type){
            $_ret[$prop] = $type;
        }
        return $_ret;
    }

    /**
     * @param $field_values
     * @return string
     */
    public function getQueryForInsert(Array $field_values){
        $_ret = false;

        $_primary_key = $this->table_param->primary_key;
        $_table = $this->table_param->table;

        $_fields = "";
        $_values = "";
        $_sep = "";

        foreach ($field_values as $field => $value) {
            if ($field != $_primary_key) {

                $_fields .= "$_sep $field";
                $_value = mysqlDAO::formatFieldInsert($this->table_param->field_types->$field->type, $value);
                $_values .= "$_sep " . $_value;

                $_sep = ",";
            }
        }

        if($_table and $_fields !== "" and $_values !== "")
            $_ret = "INSERT INTO $_table ( $_fields ) VALUES ( $_values )";

        return $_ret;
    }

    /**
     * @param array $where_field_values
     * @param array $field_values
     * @return bool|string Query
     */
    public function getQueryForUpdate(Array $where_field_values, Array $field_values) {
        $_ret = false;

        $_table = $this->table_param->table;

        $_set_exp = "";
        $_sep = "";
        foreach ($field_values as $field => $value) {
            $_set_exp .= "$_sep $field=" . mysqlDAO::formatFieldInsert($this->table_param->field_types->$field->type, $value);
            $_sep = ",";
        }

        $_where_exp = "";
        $_sep = "";
        foreach ($where_field_values as $field => $value) {
            $_where_exp .= " $_sep $field=" . mysqlDAO::formatFieldInsert($this->table_param->field_types->$field->type, $value);
            $_sep = " and ";
        }

        if($_table and $_set_exp !== "" and $_where_exp !== "")
            $_ret = "UPDATE $_table SET $_set_exp WHERE $_where_exp";

        return $_ret;
    }

    /**
     * @param $id
     * @return string
     */
    public function getQueryForDelete($id){
        $_table = $this->table_param->table;
        $_primary_key = $this->table_param->primary_key;

        $_ret = "DELETE FROM $_table WHERE $_primary_key = $id";

        return $_ret;
    }


    public function getQueryForList($where=null,$order=null){
        $_table = $this->table_param->table;

        $_ret = "SELECT * FROM $_table ";

        if($where && $where!=="")
            $_ret .= " WHERE $where ";

        if($order && $order!=="")
            $_ret .= " ORDER BY $order ";

        return $_ret;
    }

}
