<?php
require_once 'lib/customMessage/message.php';
class validateFieldForm {
	private $value;
	private $method;
	var $resultCode;
	var $resultMsg;
	var $suggestedValue;
	private $ok;
	
	/*
	 * --------------------------------------------------------------------------------
	 */
	function validateFieldForm($value, $method, $msg = "Valor no v?lido.") {
		$this->value = $value;
		$this->method = $method;
		$this->resultCode = - 1;
		$this->resultMsg = $msg;
	}
	
	/*
	 * --------------------------------------------------------------------------------
	 */
	function setMethod($method) {
		$this->method = $method;
	}
	
	/*
	 * --------------------------------------------------------------------------------
	 */
	function setValue($pValue) {
		$this->value = $pValue;
	}
	
	/*
	 * --------------------------------------------------------------------------------
	 */
	function isValid() {
		$method = $this->method;
		
		if (method_exists ( $this, $method )) {
			$this->$method ();
			$ret ["statusCode"] = $this->resultCode;
			
			$_msg = message::getMessage ( $this->resultMsg );
			if ($_msg)
				$ret ["statusMsg"] = $_msg;
			else
				$ret ["statusMsg"] = $this->resultMsg;
			
			if ($this->suggestedValue != "") {
				$ret ["suggestedValue"] = $this->suggestedValue;
			}
		} else {
			$ret ["statusCode"] = "404";
			$ret ["statusMsg"] = "metodo de validacion no encontrado ($method)";
		}
		
		return $ret;
	}
	
	/*
	 * --------------------------------------------------------------------------------
	 */
	function IsValidXML() {
		$method = $this->type;
		$this->$method ();
		return $this->xmlResult ();
	}
	
	/*
	 * --------------------------------------------------------------------------------
	 */
	function Password() {
		if (strlen ( $this->value ) > 0) {
			if (is_string ( $this->value ) and strlen ( $this->value ) >= 6) {
				
				if (strlen ( $this->value ) <= 8) {
					
					if (preg_match ( "/^[A-Z a-z 0-9 _-]{6,8}$/", $this->value )) {
						
						if (preg_match_all ( "|[0-9]|", $this->value, $a ) >= 2) {
							// if (ereg("[0-9]{2,}", $this->value)) {
							
							if (preg_match_all ( "|[A-Z a-z]|", $this->value, $a ) >= 2) {
								// if (ereg("[A-Z a-z]{2,}", $this->value)) {
								
								$this->resultCode = 200;
								$this->resultMsg = "Ok";
							} else {
								$this->resultCode = 404;
								$this->resultMsg = "formato incorrecto, su contrase?a debe contener por lo menos 2 letras.";
							}
						} else {
							
							$this->resultCode = 404;
							$this->resultMsg = "formato incorrecto, su contrase?a debe contener por lo menos 2 digitos num?ricos.";
						}
					} else {
						
						$this->resultCode = 404;
						$this->resultMsg = "formato incorrecto.";
					}
				} else {
					
					$this->resultCode = 404;
					$this->resultMsg = "formato incorrecto, demasiado largo.";
				}
			} else {
				
				$this->resultCode = 404;
				$this->resultMsg = "valor incorrecto, demasiado corto.";
			}
		} else {
			$this->resultCode = 404;
			$this->resultMsg = "El campo es obligatorio.";
		}
	}
	
	/*
	 * --------------------------------------------------------------------------------
	 */
	function Email() {
		if (strlen ( $this->value ) > 0) {
			$this->value = trim ( strtolower ( $this->value ) );
			
			if (preg_match ( "/^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/", $this->value )) {
				
				$this->resultCode = 200;
				$this->resultMsg = "Ok";
			} else {
				
				$this->resultCode = 404;
			}
		} else {
			
			$this->resultCode = 200;
			$this->resultMsg = "Ok";
		}
	}
	
	/*
	 * --------------------------------------------------------------------------------
	 */
	function StringNotNull() {
		if (strlen ( $this->value ) > 0) {
			
			if (preg_match ( "/^[A-Z|a-z|0-9|_| |[-]|\.|@]{4,50}$/", $this->value )) {
				
				$this->resultCode = 200;
				$this->resultMsg = "Ok";
			} else {
				
				$this->resultCode = 404;
			}
		} else {
			
			$this->resultCode = 404;
		}
	}
	
	/*
	 * --------------------------------------------------------------------------------
	 */
	function StringNotNull0() {
		if (strlen ( $this->value ) > 0) {
			
			if (preg_match ( "/^[A-Z | a-z | 0-9  | _ | - | \.]{1,50}$/", $this->value )) {
				
				$this->resultCode = 200;
				$this->resultMsg = "Ok";
			} else {
				
				$this->resultCode = 404;
			}
		} else {
			
			$this->resultCode = 200;
			$this->resultMsg = "Ok";
		}
	}
	
	/*
	 * --------------------------------------------------------------------------------
	 */
	function Integer() {
		if (strlen ( $this->value ) > 0) {
			if (is_numeric ( $this->value ) && $this->value > 0) {
				if (preg_match ( "/^[-]?[0-9]{1,50}$/", $this->value )) {
					
					$this->resultCode = 200;
					$this->resultMsg = "Ok";
				} else {
					
					$this->resultCode = 404;
				}
			} else {
				$this->resultCode = 404;
			}
		} else {
			
			$this->resultCode = 200;
			$this->resultMsg = "Ok";
		}
	}
	function Int() {
		return $this->Integer ();
	}
	
	/*
	 * --------------------------------------------------------------------------------
	 */
	function Fecha() {
		if (strlen ( $this->value ) > 0) {
			if ($this->value == "00/00/0000") {
				$this->resultCode = 200;
				$this->resultMsg = "Ok";
			} else {
				list ( $v_dia, $v_mes, $v_anio ) = split ( '[/.-]', $this->value );
				if (strlen ( $v_anio ) == 2)
					$v_anio = "20" . $v_anio;
				
				if (is_numeric ( $v_mes ) && is_numeric ( $v_dia ) && is_numeric ( $v_anio )) {
					if (checkdate ( intval ( $v_mes ), intval ( $v_dia ), intval ( $v_anio ) )) {
						
						$this->resultCode = 200;
						$this->resultMsg = "Ok";
					} else {
						
						$this->resultCode = 404;
					}
				} else {
					
					$this->resultCode = 404;
				}
			}
		} else {
			
			$this->resultCode = 200;
			$this->resultMsg = "Ok";
		}
	}
	function Fecha_Hora() {
		return $this->FechaYHora ();
	}
    function FechaYHora() {

        if ($this->value != "") {
            if ($this->value == "00/00/0000 00:00:00") {
                $this->resultCode = 200;
                $this->resultMsg = message::getMessage(message::VALIDACION_OK);
            } else {
            	
            	$_date = DateConversion::ViewFormatToDatetime($this->value);
            	$_date = new DateTime();
            	
            	if (isset($_date)) {
            		$this->resultCode = 200;
            		$this->resultMsg = message::getMessage(message::VALIDACION_OK);
            		                    
                } else {
                	$this->resultCode = 404;
                	$this->resultMsg = message::getMessage(message::VALIDACION_FECHA_FORMATO_INVALIDO);
                	 
                }
            }
        } else {
            $this->resultCode = 200;
            $this->resultMsg = message::getMessage(message::VALIDACION_OK);
        }
    }
	function Importe() {
		if (strlen ( $this->value ) > 0) {
			if (is_numeric ( $this->value )) {
				
				$_valid_value = round ( $this->value, 2 );
				if ($_valid_value == $this->value) {
					$this->resultCode = 200;
					$this->resultMsg = "Ok";
				} else {
					$this->resultCode = 404;
					$this->suggestedValue = $_valid_value;
				}
			} else {
				$this->resultCode = 404;
			}
		} else {
			$this->resultCode = 200;
			$this->resultMsg = "Ok";
		}
	}
	function Obligatorio() {
		if (strlen ( $this->value ) > 0) {
			$this->resultCode = 200;
			$this->resultMsg = "Ok";
		} else {
			$this->resultCode = 404;
		}
	}
	function IpAddress() {
		if (strlen ( $this->value ) > 0) {
			if (filter_var ( $this->value, FILTER_VALIDATE_IP )) {
				$this->resultCode = 200;
				$this->resultMsg = "Ok";
			} else {
				$this->resultCode = 404;
			}
		} else {
			$this->resultCode = 200;
			$this->resultMsg = "Ok";
		}
	}
	function Url() {
		if (strlen ( $this->value ) > 0) {
			if (filter_var ( $this->value, FILTER_VALIDATE_URL )) {
				$this->resultCode = 200;
				$this->resultMsg = "Ok";
			} else {
				$this->resultCode = 404;
			}
		} else {
			$this->resultCode = 200;
			$this->resultMsg = "Ok";
		}
	}
	public function validaCUIT() {
		if (strlen ( $this->value ) > 0) {
			$v_cuit = str_replace ( "-", "", $this->value );
			
			if (preg_match ( "/^[0-9]{11}$/", $v_cuit )) {
				if (self::verificarNroCUIT ( $v_cuit )) {
					
					$this->resultCode = 200;
					$this->resultMsg = "Ok";
				} else {
					$this->resultCode = 404;
				}
			} else {
				$this->resultCode = 404;
			}
		} else {
			$this->resultCode = 200;
			$this->resultMsg = "Ok";
		}
	}
	static private function verificarNroCUIT($p_nrocuit) {
		$v_res = false;
		$a_digitos = array (
				5,
				4,
				3,
				2,
				7,
				6,
				5,
				4,
				3,
				2 
		);
		$a_nrocuit = str_split ( $p_nrocuit );
		$v_dig_verif = 0;
		
		if ($p_nrocuit !== "00000000000") {
			for($i = 0; $i < strlen ( $p_nrocuit ) - 1; $i ++) {
				$v_dig_verif = $v_dig_verif + ($a_nrocuit [$i] * $a_digitos [$i]);
			}
			
			$v_dig_verif = ($v_dig_verif % 11);
			
			if ($v_dig_verif !== 0)
				$v_dig_verif = $v_dig_verif - 11;
			
			if (abs ( $v_dig_verif ) == $a_nrocuit [$i]) {
				$v_res = true;
			}
		}
		
		return $v_res;
	}
	public function Float() {
		if (strlen ( $this->value ) > 0) {
			if (is_numeric ( $this->value )) {
				$this->resultCode = 200;
				$this->resultMsg = "Ok";
			} else {
				$this->resultCode = 404;
			}
		}
	}
	public function mayorCero() {
		if (strlen ( $this->value ) > 0) {
			if (is_numeric ( $this->value ) && $this->value > 0) {
				$this->resultCode = 200;
				$this->resultMsg = "Ok";
			} else {
				$this->resultCode = 404;
			}
		}
	}
}

?>